/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 730
#ifdef HAVE_CONFIG_H
#line 730
# include <config.h>
#line 730
#endif
#line 730
#include <sys/types.h>
#line 730

#line 730
#include "mailfromd.h"
#line 730
#include "prog.h"
#line 730
#include "builtin.h"
#line 730

#line 730

#line 767 "../../src/builtin/snarf.m4"

#line 1 "msg.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2008-2018 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include "msg.h"
#include "global.h"

static size_t nmsgs = MAX_MSGS;

static struct mu_cfg_param msg_cfg_param[] = {
	{ "max-open-messages", mu_c_size, &nmsgs, 0, NULL,
	  N_("Maximum number of messages to open simultaneously.") },
	{ NULL }
};

static void *
alloc_msgs()
{
	return mu_calloc(nmsgs, sizeof(struct mf_message));
}

static void
destroy_msgs(void *data)
{
	struct mf_message *mtab = data;
	struct mf_message *p;
	for (p = mtab; p < mtab + nmsgs; p++) {
		bi_close_message(p);
	}
	free(mtab);
}

void
drop_current_message(void *data)
{
	int i;
	struct mf_message *tab = data;
	for (i = 0; i < nmsgs; i++)
		if (tab[i].msg && tab[i].type == MF_MSG_CURRENT) {
			bi_close_message(&tab[i]);
			break;
		}
}


#line 57

#line 57
static int MSGTAB_id;
#line 57 "msg.bi"


static int
find_slot(struct mf_message *tab)
{
	int i;
	for (i = 0; i < nmsgs; i++)
		if (tab[i].msg == NULL)
			return i;
	return -1;
}

static int
do_msg_close(void *item, void *data)
{
	bi_close_message(item);
	return 0;
}

void
bi_close_message(struct mf_message *mp)
{
	if (mp->msg) {
		mu_stream_destroy(&mp->mstr);
		mu_stream_destroy(&mp->bstr);
		if (mp->type == MF_MSG_STANDALONE)
			mu_message_destroy(&mp->msg,
					   mu_message_get_owner(mp->msg));
		mu_list_foreach(mp->msglist, do_msg_close, NULL);
		mu_list_destroy(&mp->msglist);
		free(mp->buf);
		memset(mp, 0, sizeof *mp);
	}
}

int
bi_message_register(eval_environ_t env,
		    mu_list_t msglist, mu_message_t msg, int type)
{
	struct mf_message *msgtab = env_get_builtin_priv(env,MSGTAB_id);
	int idx = find_slot(msgtab);
	if (idx >= 0) {
		struct mf_message *mp = msgtab + idx;
		mp->msg = msg;
		mp->type = type;
		mu_list_create(&mp->msglist);
		if (msglist)
			mu_list_append(msglist, mp);
	}
	return idx;
}

int
bi_get_current_message(eval_environ_t env)
{
	int i;
	struct mf_message *tab = env_get_builtin_priv(env,MSGTAB_id);
	for (i = 0; i < nmsgs; i++)
		if (tab[i].msg && tab[i].type == MF_MSG_CURRENT)
			return i;
	return -1;
}


#line 132


#line 143


#line 154


#line 172


mu_message_t
bi_message_from_descr(eval_environ_t env, int nmsg)
{
	
#line 177
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 177
	struct mf_message *mp;
#line 177
			
#line 177
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 177
		(
#line 177
	env_throw_bi(env, mfe_range, NULL, _("invalid message descriptor"))
#line 177
)
#line 177
;
#line 177
	mp = mtab + nmsg;
#line 177
		if (!(mp->msg))
#line 177
		(
#line 177
	env_throw_bi(env, mfe_failure, NULL, _("message not open"))
#line 177
)
#line 177

#line 177
;
	return mp->msg;
}

/* void message_close(number msg) */
void
#line 182
bi_message_close(eval_environ_t env)
#line 182

#line 182

#line 182 "msg.bi"
{
#line 182
	
#line 182

#line 182

#line 182
long  nmsg;
#line 182
        
#line 182
get_numeric_arg(env, 0, &nmsg);
#line 182
        
#line 182

#line 182
        adjust_stack(env, 1);
#line 182

#line 182

#line 182
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 182
		prog_trace(env, "message_close %lu",nmsg);;
#line 182

{
	
#line 184
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 184
	struct mf_message *mp;
#line 184
			
#line 184
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 184
		(
#line 184
	env_throw_bi(env, mfe_range, "message_close", _("invalid message descriptor"))
#line 184
)
#line 184
;
#line 184
	mp = mtab + nmsg;
#line 184
		if (!(mp->msg))
#line 184
		(
#line 184
	env_throw_bi(env, mfe_failure, "message_close", _("message not open"))
#line 184
)
#line 184

#line 184
;
	bi_close_message(mp);
}

#line 187
        env_function_cleanup_flush(env, NULL);
#line 187
	return;
#line 187
}

/* number message_size(number nmsg) */
void
#line 190
bi_message_size(eval_environ_t env)
#line 190

#line 190

#line 190 "msg.bi"
{
#line 190
	
#line 190

#line 190

#line 190
long  nmsg;
#line 190
        
#line 190
get_numeric_arg(env, 0, &nmsg);
#line 190
        
#line 190

#line 190
        adjust_stack(env, 1);
#line 190

#line 190

#line 190
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 190
		prog_trace(env, "message_size %lu",nmsg);;
#line 190

{
	int rc;
	size_t size;
	
#line 194
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 194
	struct mf_message *mp;
#line 194
			
#line 194
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 194
		(
#line 194
	env_throw_bi(env, mfe_range, "message_size", _("invalid message descriptor"))
#line 194
)
#line 194
;
#line 194
	mp = mtab + nmsg;
#line 194
		if (!(mp->msg))
#line 194
		(
#line 194
	env_throw_bi(env, mfe_failure, "message_size", _("message not open"))
#line 194
)
#line 194

#line 194
;
	
	rc = mu_message_size(mp->msg, &size);
		if (!(rc == 0))
#line 197
		(
#line 197
	env_throw_bi(env, mfe_failure, "message_size", "%s",mu_strerror(rc))
#line 197
)
#line 199
;
		if (!(size < LONG_MAX))
#line 200
		(
#line 200
	env_throw_bi(env, mfe_range, "message_size", _("message size out of representable range"))
#line 200
)
#line 202
;
	
#line 203
do {
#line 203
  push(env, (STKVAL)(mft_number)((long)size));
#line 203
  goto endlab;
#line 203
} while (0);
}	
endlab:
#line 205
        env_function_cleanup_flush(env, NULL);
#line 205
	return;
#line 205
}

/* number message_lines(number nmsg) */
void
#line 208
bi_message_lines(eval_environ_t env)
#line 208

#line 208

#line 208 "msg.bi"
{
#line 208
	
#line 208

#line 208

#line 208
long  nmsg;
#line 208
        
#line 208
get_numeric_arg(env, 0, &nmsg);
#line 208
        
#line 208

#line 208
        adjust_stack(env, 1);
#line 208

#line 208

#line 208
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 208
		prog_trace(env, "message_lines %lu",nmsg);;
#line 208

{
	int rc;
	size_t lines;
	
#line 212
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 212
	struct mf_message *mp;
#line 212
			
#line 212
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 212
		(
#line 212
	env_throw_bi(env, mfe_range, "message_lines", _("invalid message descriptor"))
#line 212
)
#line 212
;
#line 212
	mp = mtab + nmsg;
#line 212
		if (!(mp->msg))
#line 212
		(
#line 212
	env_throw_bi(env, mfe_failure, "message_lines", _("message not open"))
#line 212
)
#line 212

#line 212
;

	rc = mu_message_lines(mp->msg, &lines);
		if (!(rc == 0))
#line 215
		(
#line 215
	env_throw_bi(env, mfe_failure, "message_lines", "%s",mu_strerror(rc))
#line 215
)
#line 218
;
	
#line 219
do {
#line 219
  push(env, (STKVAL)(mft_number)(lines));
#line 219
  goto endlab;
#line 219
} while (0);
}
endlab:
#line 221
        env_function_cleanup_flush(env, NULL);
#line 221
	return;
#line 221
}

/* number message_body_size(number nmsg) */
void
#line 224
bi_message_body_size(eval_environ_t env)
#line 224

#line 224

#line 224 "msg.bi"
{
#line 224
	
#line 224

#line 224

#line 224
long  nmsg;
#line 224
        
#line 224
get_numeric_arg(env, 0, &nmsg);
#line 224
        
#line 224

#line 224
        adjust_stack(env, 1);
#line 224

#line 224

#line 224
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 224
		prog_trace(env, "message_body_size %lu",nmsg);;
#line 224

{
	int rc;
	size_t size;
	
#line 228
	
#line 228
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 228
	struct mf_message *mp;
#line 228
			
#line 228
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 228
		(
#line 228
	env_throw_bi(env, mfe_range, "message_body_size", _("invalid message descriptor"))
#line 228
)
#line 228
;
#line 228
	mp = mtab + nmsg;
#line 228
		if (!(mp->msg))
#line 228
		(
#line 228
	env_throw_bi(env, mfe_failure, "message_body_size", _("message not open"))
#line 228
)
#line 228

#line 228
;
#line 228
	if (!mp->body) {
#line 228
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 228
			if (!(rc == 0))
#line 228
		(
#line 228
	env_throw_bi(env, mfe_failure, "message_body_size", "mu_message_get_body: %s",mu_strerror(rc))
#line 228
)
#line 228
;
#line 228
	}	  
#line 228
;
	
	rc = mu_body_size(mp->body, &size);
		if (!(rc == 0))
#line 231
		(
#line 231
	env_throw_bi(env, mfe_failure, "message_body_size", "%s",mu_strerror(rc))
#line 231
)
#line 233
;
		if (!(size < LONG_MAX))
#line 234
		(
#line 234
	env_throw_bi(env, mfe_range, "message_body_size", _("body size out of representable range"))
#line 234
)
#line 236
;
	
#line 237
do {
#line 237
  push(env, (STKVAL)(mft_number)((long)size));
#line 237
  goto endlab;
#line 237
} while (0);
}
endlab:
#line 239
        env_function_cleanup_flush(env, NULL);
#line 239
	return;
#line 239
}

/* boolean message_body_is_empty(number nmsg) */
void
#line 242
bi_message_body_is_empty(eval_environ_t env)
#line 242

#line 242

#line 242 "msg.bi"
{
#line 242
	
#line 242

#line 242

#line 242
long  nmsg;
#line 242
        
#line 242
get_numeric_arg(env, 0, &nmsg);
#line 242
        
#line 242

#line 242
        adjust_stack(env, 1);
#line 242

#line 242

#line 242
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 242
		prog_trace(env, "message_body_is_empty %lu",nmsg);;
#line 242

{
        int rc, res;
	char c;
	size_t n;
	mu_stream_t input, fstr;
	char *encoding = NULL;

	
#line 250
	
#line 250
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 250
	struct mf_message *mp;
#line 250
			
#line 250
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 250
		(
#line 250
	env_throw_bi(env, mfe_range, "message_body_is_empty", _("invalid message descriptor"))
#line 250
)
#line 250
;
#line 250
	mp = mtab + nmsg;
#line 250
		if (!(mp->msg))
#line 250
		(
#line 250
	env_throw_bi(env, mfe_failure, "message_body_is_empty", _("message not open"))
#line 250
)
#line 250

#line 250
;
#line 250
	if (!mp->body) {
#line 250
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 250
			if (!(rc == 0))
#line 250
		(
#line 250
	env_throw_bi(env, mfe_failure, "message_body_is_empty", "mu_message_get_body: %s",mu_strerror(rc))
#line 250
)
#line 250
;
#line 250
	}	  
#line 250
	if (!mp->hdr) {
#line 250
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 250
			if (!(rc == 0))
#line 250
		(
#line 250
	env_throw_bi(env, mfe_failure, "message_body_is_empty", "mu_message_get_header: %s",mu_strerror(rc))
#line 250
)
#line 250
;
#line 250
	}	  
#line 250
;
	rc = mu_body_size(mp->body, &n);
		if (!(rc == 0))
#line 252
		(
#line 252
	env_throw_bi(env, mfe_failure, "message_body_is_empty", "mu_body_size: %s",mu_strerror(rc))
#line 252
)
#line 254
;
	if (n == 0)
		
#line 256
do {
#line 256
  push(env, (STKVAL)(mft_number)(1));
#line 256
  goto endlab;
#line 256
} while (0);

	rc = mu_body_get_streamref(mp->body, &input);
		if (!(rc == 0))
#line 259
		(
#line 259
	env_throw_bi(env, mfe_failure, "message_body_is_empty", "mu_body_get_streamref: %s",mu_strerror(rc))
#line 259
)
#line 261
;

	mu_header_aget_value_unfold(mp->hdr,
				    MU_HEADER_CONTENT_TRANSFER_ENCODING,
				    &encoding);
	if (encoding) {
		rc = mu_filter_create(&fstr, input, encoding,
				      MU_FILTER_DECODE,
				      MU_STREAM_READ);
		if (rc) {
			mu_error(_("can't create filter for encoding %s: %s"),
				 encoding, mu_strerror(rc));
			fstr = input;
		} else 
			mu_stream_unref(input);
		free(encoding);
	} else
		fstr = input;
	
	res = 1;
	while (mu_stream_read(fstr, &c, 1, &n) == 0 && n > 0) {
		if (!mu_isspace(c)) {
			res = 0;
			break;
		}
	}
	mu_stream_unref(fstr);
	
#line 288
do {
#line 288
  push(env, (STKVAL)(mft_number)(res));
#line 288
  goto endlab;
#line 288
} while (0);
}
endlab:
#line 290
        env_function_cleanup_flush(env, NULL);
#line 290
	return;
#line 290
}
	 
/* number message_body_lines(number nmsg) */
void
#line 293
bi_message_body_lines(eval_environ_t env)
#line 293

#line 293

#line 293 "msg.bi"
{
#line 293
	
#line 293

#line 293

#line 293
long  nmsg;
#line 293
        
#line 293
get_numeric_arg(env, 0, &nmsg);
#line 293
        
#line 293

#line 293
        adjust_stack(env, 1);
#line 293

#line 293

#line 293
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 293
		prog_trace(env, "message_body_lines %lu",nmsg);;
#line 293

{
	int rc;
	size_t lines;
	
#line 297
	
#line 297
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 297
	struct mf_message *mp;
#line 297
			
#line 297
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 297
		(
#line 297
	env_throw_bi(env, mfe_range, "message_body_lines", _("invalid message descriptor"))
#line 297
)
#line 297
;
#line 297
	mp = mtab + nmsg;
#line 297
		if (!(mp->msg))
#line 297
		(
#line 297
	env_throw_bi(env, mfe_failure, "message_body_lines", _("message not open"))
#line 297
)
#line 297

#line 297
;
#line 297
	if (!mp->body) {
#line 297
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 297
			if (!(rc == 0))
#line 297
		(
#line 297
	env_throw_bi(env, mfe_failure, "message_body_lines", "mu_message_get_body: %s",mu_strerror(rc))
#line 297
)
#line 297
;
#line 297
	}	  
#line 297
;

	rc = mu_body_lines(mp->body, &lines);
		if (!(rc == 0))
#line 300
		(
#line 300
	env_throw_bi(env, mfe_failure, "message_body_lines", "%s",mu_strerror(rc))
#line 300
)
#line 303
;
	
#line 304
do {
#line 304
  push(env, (STKVAL)(mft_number)(lines));
#line 304
  goto endlab;
#line 304
} while (0);
}
endlab:
#line 306
        env_function_cleanup_flush(env, NULL);
#line 306
	return;
#line 306
}


/* Headers */

/* number message_header_size(number nmsg) */
void
#line 312
bi_message_header_size(eval_environ_t env)
#line 312

#line 312

#line 312 "msg.bi"
{
#line 312
	
#line 312

#line 312

#line 312
long  nmsg;
#line 312
        
#line 312
get_numeric_arg(env, 0, &nmsg);
#line 312
        
#line 312

#line 312
        adjust_stack(env, 1);
#line 312

#line 312

#line 312
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 312
		prog_trace(env, "message_header_size %lu",nmsg);;
#line 312

{
	int rc;
	size_t size;
	
#line 316
	
#line 316
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 316
	struct mf_message *mp;
#line 316
			
#line 316
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 316
		(
#line 316
	env_throw_bi(env, mfe_range, "message_header_size", _("invalid message descriptor"))
#line 316
)
#line 316
;
#line 316
	mp = mtab + nmsg;
#line 316
		if (!(mp->msg))
#line 316
		(
#line 316
	env_throw_bi(env, mfe_failure, "message_header_size", _("message not open"))
#line 316
)
#line 316

#line 316
;
#line 316
	if (!mp->hdr) {
#line 316
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 316
			if (!(rc == 0))
#line 316
		(
#line 316
	env_throw_bi(env, mfe_failure, "message_header_size", "mu_message_get_header: %s",mu_strerror(rc))
#line 316
)
#line 316
;
#line 316
	}	  
#line 316
;
	
	rc = mu_header_size(mp->hdr, &size);
		if (!(rc == 0))
#line 319
		(
#line 319
	env_throw_bi(env, mfe_failure, "message_header_size", "%s",mu_strerror(rc))
#line 319
)
#line 321
;
		if (!(size < LONG_MAX))
#line 322
		(
#line 322
	env_throw_bi(env, mfe_range, "message_header_size", _("header size out of representable range"))
#line 322
)
#line 324
;
	
#line 325
do {
#line 325
  push(env, (STKVAL)(mft_number)((long)size));
#line 325
  goto endlab;
#line 325
} while (0);
}
endlab:
#line 327
        env_function_cleanup_flush(env, NULL);
#line 327
	return;
#line 327
}

/* number message_header_lines(number nmsg) */
void
#line 330
bi_message_header_lines(eval_environ_t env)
#line 330

#line 330

#line 330 "msg.bi"
{
#line 330
	
#line 330

#line 330

#line 330
long  nmsg;
#line 330
        
#line 330
get_numeric_arg(env, 0, &nmsg);
#line 330
        
#line 330

#line 330
        adjust_stack(env, 1);
#line 330

#line 330

#line 330
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 330
		prog_trace(env, "message_header_lines %lu",nmsg);;
#line 330

{
	int rc;
	size_t lines;
	
#line 334
	
#line 334
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 334
	struct mf_message *mp;
#line 334
			
#line 334
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 334
		(
#line 334
	env_throw_bi(env, mfe_range, "message_header_lines", _("invalid message descriptor"))
#line 334
)
#line 334
;
#line 334
	mp = mtab + nmsg;
#line 334
		if (!(mp->msg))
#line 334
		(
#line 334
	env_throw_bi(env, mfe_failure, "message_header_lines", _("message not open"))
#line 334
)
#line 334

#line 334
;
#line 334
	if (!mp->hdr) {
#line 334
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 334
			if (!(rc == 0))
#line 334
		(
#line 334
	env_throw_bi(env, mfe_failure, "message_header_lines", "mu_message_get_header: %s",mu_strerror(rc))
#line 334
)
#line 334
;
#line 334
	}	  
#line 334
;

	rc = mu_header_lines(mp->hdr, &lines);
		if (!(rc == 0))
#line 337
		(
#line 337
	env_throw_bi(env, mfe_failure, "message_header_lines", "%s",mu_strerror(rc))
#line 337
)
#line 340
;
	
#line 341
do {
#line 341
  push(env, (STKVAL)(mft_number)(lines));
#line 341
  goto endlab;
#line 341
} while (0);
}
endlab:
#line 343
        env_function_cleanup_flush(env, NULL);
#line 343
	return;
#line 343
}

/* number message_header_count(number nmsg[; string name]) */
void
#line 346
bi_message_header_count(eval_environ_t env)
#line 346

#line 346

#line 346 "msg.bi"
{
#line 346
	
#line 346

#line 346
long __bi_argcnt;
#line 346
long  nmsg;
#line 346
        char *  name;
#line 346
        
#line 346
get_numeric_arg(env, 1, &nmsg);
#line 346
        get_string_arg(env, 2, &name);
#line 346
        
#line 346
get_numeric_arg(env, 0, &__bi_argcnt);
#line 346
        adjust_stack(env, __bi_argcnt + 1);
#line 346

#line 346

#line 346
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 346
		prog_trace(env, "message_header_count %lu %s",nmsg, ((__bi_argcnt > 1) ? name : ""));;

{
	int rc;
	size_t count;
	
#line 351
	
#line 351
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 351
	struct mf_message *mp;
#line 351
			
#line 351
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 351
		(
#line 351
	env_throw_bi(env, mfe_range, "message_header_count", _("invalid message descriptor"))
#line 351
)
#line 351
;
#line 351
	mp = mtab + nmsg;
#line 351
		if (!(mp->msg))
#line 351
		(
#line 351
	env_throw_bi(env, mfe_failure, "message_header_count", _("message not open"))
#line 351
)
#line 351

#line 351
;
#line 351
	if (!mp->hdr) {
#line 351
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 351
			if (!(rc == 0))
#line 351
		(
#line 351
	env_throw_bi(env, mfe_failure, "message_header_count", "mu_message_get_header: %s",mu_strerror(rc))
#line 351
)
#line 351
;
#line 351
	}	  
#line 351
;

	rc = mu_header_get_field_count(mp->hdr, &count);
		if (!(rc == 0))
#line 354
		(
#line 354
	env_throw_bi(env, mfe_failure, "message_header_count", "%s",mu_strerror(rc))
#line 354
)
#line 357
;
	
	if ((__bi_argcnt > 1)) {
		size_t n;

		for (n = 1; n <= count; n++) {
			const char *val;
			rc = mu_header_sget_value_n(mp->hdr, name, n, &val);
			if (rc == MU_ERR_NOENT)
				break;
			else if (rc)
				(
#line 368
	env_throw_bi(env, mfe_failure, "message_header_count", "%s",mu_strerror(rc))
#line 368
);
		}
		count = n - 1;
	}
	
#line 372
do {
#line 372
  push(env, (STKVAL)(mft_number)(count));
#line 372
  goto endlab;
#line 372
} while (0);
}
endlab:
#line 374
        env_function_cleanup_flush(env, NULL);
#line 374
	return;
#line 374
}

/* bool message_has_header(number msg, string header[, number idx]) */
void
#line 377
bi_message_has_header(eval_environ_t env)
#line 377

#line 377

#line 377 "msg.bi"
{
#line 377
	
#line 377

#line 377
long __bi_argcnt;
#line 377
long  nmsg;
#line 377
        char *  header;
#line 377
        long  idx;
#line 377
        
#line 377
get_numeric_arg(env, 1, &nmsg);
#line 377
        get_string_arg(env, 2, &header);
#line 377
        get_numeric_arg(env, 3, &idx);
#line 377
        
#line 377
get_numeric_arg(env, 0, &__bi_argcnt);
#line 377
        adjust_stack(env, __bi_argcnt + 1);
#line 377

#line 377

#line 377
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 377
		prog_trace(env, "message_has_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 382
	
#line 382
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 382
	struct mf_message *mp;
#line 382
			
#line 382
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 382
		(
#line 382
	env_throw_bi(env, mfe_range, "message_has_header", _("invalid message descriptor"))
#line 382
)
#line 382
;
#line 382
	mp = mtab + nmsg;
#line 382
		if (!(mp->msg))
#line 382
		(
#line 382
	env_throw_bi(env, mfe_failure, "message_has_header", _("message not open"))
#line 382
)
#line 382

#line 382
;
#line 382
	if (!mp->hdr) {
#line 382
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 382
			if (!(rc == 0))
#line 382
		(
#line 382
	env_throw_bi(env, mfe_failure, "message_has_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 382
)
#line 382
;
#line 382
	}	  
#line 382
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
 	
#line 385
do {
#line 385
  push(env, (STKVAL)(mft_number)(rc == 0));
#line 385
  goto endlab;
#line 385
} while (0);
}
endlab:
#line 387
        env_function_cleanup_flush(env, NULL);
#line 387
	return;
#line 387
}

/* string message_find_header(number msg, string header[, number idx]) */
void
#line 390
bi_message_find_header(eval_environ_t env)
#line 390

#line 390

#line 390 "msg.bi"
{
#line 390
	
#line 390

#line 390
long __bi_argcnt;
#line 390
long  nmsg;
#line 390
        char * MFL_DATASEG header;
#line 390
        long  idx;
#line 390
        
#line 390
get_numeric_arg(env, 1, &nmsg);
#line 390
        get_string_arg(env, 2, &header);
#line 390
        get_numeric_arg(env, 3, &idx);
#line 390
        
#line 390
get_numeric_arg(env, 0, &__bi_argcnt);
#line 390
        adjust_stack(env, __bi_argcnt + 1);
#line 390

#line 390

#line 390
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 390
		prog_trace(env, "message_find_header %lu %s %lu",nmsg, header, ((__bi_argcnt > 2) ? idx : 0));;

{
	int rc;
	const char *val;
	
#line 395
	
#line 395
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 395
	struct mf_message *mp;
#line 395
			
#line 395
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 395
		(
#line 395
	env_throw_bi(env, mfe_range, "message_find_header", _("invalid message descriptor"))
#line 395
)
#line 395
;
#line 395
	mp = mtab + nmsg;
#line 395
		if (!(mp->msg))
#line 395
		(
#line 395
	env_throw_bi(env, mfe_failure, "message_find_header", _("message not open"))
#line 395
)
#line 395

#line 395
;
#line 395
	if (!mp->hdr) {
#line 395
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 395
			if (!(rc == 0))
#line 395
		(
#line 395
	env_throw_bi(env, mfe_failure, "message_find_header", "mu_message_get_header: %s",mu_strerror(rc))
#line 395
)
#line 395
;
#line 395
	}	  
#line 395
;

	rc = mu_header_sget_value_n(mp->hdr, header, ((__bi_argcnt > 2) ? idx : 1), &val);
	if (rc == MU_ERR_NOENT)
		(
#line 399
	env_throw_bi(env, mfe_not_found, "message_find_header", _("header not found"))
#line 399
);
	else if (rc)
		(
#line 401
	env_throw_bi(env, mfe_failure, "message_find_header", "%s",mu_strerror(rc))
#line 401
);
	
#line 402
do {
#line 402
  pushs(env, val);
#line 402
  goto endlab;
#line 402
} while (0);
}
endlab:
#line 404
        env_function_cleanup_flush(env, NULL);
#line 404
	return;
#line 404
}

/* string message_nth_header_name(number msg, number n) */
void
#line 407
bi_message_nth_header_name(eval_environ_t env)
#line 407

#line 407

#line 407 "msg.bi"
{
#line 407
	
#line 407

#line 407

#line 407
long  nmsg;
#line 407
        long  idx;
#line 407
        
#line 407
get_numeric_arg(env, 0, &nmsg);
#line 407
        get_numeric_arg(env, 1, &idx);
#line 407
        
#line 407

#line 407
        adjust_stack(env, 2);
#line 407

#line 407

#line 407
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 407
		prog_trace(env, "message_nth_header_name %lu %lu",nmsg, idx);;
#line 407

{
	int rc;
	const char *val;
	
#line 411
	
#line 411
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 411
	struct mf_message *mp;
#line 411
			
#line 411
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 411
		(
#line 411
	env_throw_bi(env, mfe_range, "message_nth_header_name", _("invalid message descriptor"))
#line 411
)
#line 411
;
#line 411
	mp = mtab + nmsg;
#line 411
		if (!(mp->msg))
#line 411
		(
#line 411
	env_throw_bi(env, mfe_failure, "message_nth_header_name", _("message not open"))
#line 411
)
#line 411

#line 411
;
#line 411
	if (!mp->hdr) {
#line 411
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 411
			if (!(rc == 0))
#line 411
		(
#line 411
	env_throw_bi(env, mfe_failure, "message_nth_header_name", "mu_message_get_header: %s",mu_strerror(rc))
#line 411
)
#line 411
;
#line 411
	}	  
#line 411
;
	
	rc = mu_header_sget_field_name(mp->hdr, idx, &val);
	if (rc == MU_ERR_NOENT)
		(
#line 415
	env_throw_bi(env, mfe_range, "message_nth_header_name", "header index out of range")
#line 415
);
	else if (rc)
		(
#line 417
	env_throw_bi(env, mfe_failure, "message_nth_header_name", "%s",mu_strerror(rc))
#line 417
);
	
#line 418
do {
#line 418
  pushs(env, val);
#line 418
  goto endlab;
#line 418
} while (0);
}
endlab:
#line 420
        env_function_cleanup_flush(env, NULL);
#line 420
	return;
#line 420
}

/* string message_nth_header_value(number msg, number n) */
void
#line 423
bi_message_nth_header_value(eval_environ_t env)
#line 423

#line 423

#line 423 "msg.bi"
{
#line 423
	
#line 423

#line 423

#line 423
long  nmsg;
#line 423
        long  idx;
#line 423
        
#line 423
get_numeric_arg(env, 0, &nmsg);
#line 423
        get_numeric_arg(env, 1, &idx);
#line 423
        
#line 423

#line 423
        adjust_stack(env, 2);
#line 423

#line 423

#line 423
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 423
		prog_trace(env, "message_nth_header_value %lu %lu",nmsg, idx);;
#line 423

{
	int rc;
	const char *val;
	
#line 427
	
#line 427
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 427
	struct mf_message *mp;
#line 427
			
#line 427
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 427
		(
#line 427
	env_throw_bi(env, mfe_range, "message_nth_header_value", _("invalid message descriptor"))
#line 427
)
#line 427
;
#line 427
	mp = mtab + nmsg;
#line 427
		if (!(mp->msg))
#line 427
		(
#line 427
	env_throw_bi(env, mfe_failure, "message_nth_header_value", _("message not open"))
#line 427
)
#line 427

#line 427
;
#line 427
	if (!mp->hdr) {
#line 427
		int rc = mu_message_get_header(mp->msg, &mp->hdr);
#line 427
			if (!(rc == 0))
#line 427
		(
#line 427
	env_throw_bi(env, mfe_failure, "message_nth_header_value", "mu_message_get_header: %s",mu_strerror(rc))
#line 427
)
#line 427
;
#line 427
	}	  
#line 427
;
	
	rc = mu_header_sget_field_value(mp->hdr, idx, &val);
	if (rc == MU_ERR_NOENT)
		(
#line 431
	env_throw_bi(env, mfe_range, "message_nth_header_value", "header index out of range")
#line 431
);
	else if (rc)
		(
#line 433
	env_throw_bi(env, mfe_failure, "message_nth_header_value", "%s",mu_strerror(rc))
#line 433
);
	
#line 434
do {
#line 434
  pushs(env, val);
#line 434
  goto endlab;
#line 434
} while (0);
}
endlab:
#line 436
        env_function_cleanup_flush(env, NULL);
#line 436
	return;
#line 436
}


/* Multipart messages */

/* bool message_is_multipart(number msg) */
void
#line 442
bi_message_is_multipart(eval_environ_t env)
#line 442

#line 442

#line 442 "msg.bi"
{
#line 442
	
#line 442

#line 442

#line 442
long  nmsg;
#line 442
        
#line 442
get_numeric_arg(env, 0, &nmsg);
#line 442
        
#line 442

#line 442
        adjust_stack(env, 1);
#line 442

#line 442

#line 442
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 442
		prog_trace(env, "message_is_multipart %lu",nmsg);;
#line 442

{
	int rc, res;
	
#line 445
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 445
	struct mf_message *mp;
#line 445
			
#line 445
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 445
		(
#line 445
	env_throw_bi(env, mfe_range, "message_is_multipart", _("invalid message descriptor"))
#line 445
)
#line 445
;
#line 445
	mp = mtab + nmsg;
#line 445
		if (!(mp->msg))
#line 445
		(
#line 445
	env_throw_bi(env, mfe_failure, "message_is_multipart", _("message not open"))
#line 445
)
#line 445

#line 445
;

	rc = mu_message_is_multipart(mp->msg, &res);
		if (!(rc == 0))
#line 448
		(
#line 448
	env_throw_bi(env, mfe_failure, "message_is_multipart", "%s",mu_strerror(rc))
#line 448
)
#line 451
;
	
#line 452
do {
#line 452
  push(env, (STKVAL)(mft_number)(res));
#line 452
  goto endlab;
#line 452
} while (0);
}
endlab:
#line 454
        env_function_cleanup_flush(env, NULL);
#line 454
	return;
#line 454
}

/* number message_count_parts(number msg) */
void
#line 457
bi_message_count_parts(eval_environ_t env)
#line 457

#line 457

#line 457 "msg.bi"
{
#line 457
	
#line 457

#line 457

#line 457
long  nmsg;
#line 457
        
#line 457
get_numeric_arg(env, 0, &nmsg);
#line 457
        
#line 457

#line 457
        adjust_stack(env, 1);
#line 457

#line 457

#line 457
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 457
		prog_trace(env, "message_count_parts %lu",nmsg);;
#line 457

{
	int rc;
	size_t count;
	
#line 461
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 461
	struct mf_message *mp;
#line 461
			
#line 461
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 461
		(
#line 461
	env_throw_bi(env, mfe_range, "message_count_parts", _("invalid message descriptor"))
#line 461
)
#line 461
;
#line 461
	mp = mtab + nmsg;
#line 461
		if (!(mp->msg))
#line 461
		(
#line 461
	env_throw_bi(env, mfe_failure, "message_count_parts", _("message not open"))
#line 461
)
#line 461

#line 461
;
	rc = mu_message_get_num_parts(mp->msg, &count);
		if (!(rc == 0))
#line 463
		(
#line 463
	env_throw_bi(env, mfe_failure, "message_count_parts", "%s",mu_strerror(rc))
#line 463
)
#line 466
;
	
#line 467
do {
#line 467
  push(env, (STKVAL)(mft_number)(count));
#line 467
  goto endlab;
#line 467
} while (0);
}
endlab:
#line 469
        env_function_cleanup_flush(env, NULL);
#line 469
	return;
#line 469
}

/* number message_get_part(number msg, number idx) */
void
#line 472
bi_message_get_part(eval_environ_t env)
#line 472

#line 472

#line 472 "msg.bi"
{
#line 472
	
#line 472

#line 472

#line 472
long  nmsg;
#line 472
        long  idx;
#line 472
        
#line 472
get_numeric_arg(env, 0, &nmsg);
#line 472
        get_numeric_arg(env, 1, &idx);
#line 472
        
#line 472

#line 472
        adjust_stack(env, 2);
#line 472

#line 472

#line 472
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 472
		prog_trace(env, "message_get_part %lu %lu",nmsg, idx);;
#line 472

{
	int rc;
	mu_message_t msg;
	
#line 476
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 476
	struct mf_message *mp;
#line 476
			
#line 476
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 476
		(
#line 476
	env_throw_bi(env, mfe_range, "message_get_part", _("invalid message descriptor"))
#line 476
)
#line 476
;
#line 476
	mp = mtab + nmsg;
#line 476
		if (!(mp->msg))
#line 476
		(
#line 476
	env_throw_bi(env, mfe_failure, "message_get_part", _("message not open"))
#line 476
)
#line 476

#line 476
;

	rc = mu_message_get_part(mp->msg, idx, &msg);
		if (!(rc == 0))
#line 479
		(
#line 479
	env_throw_bi(env, mfe_failure, "message_get_part", "%s",mu_strerror(rc))
#line 479
)
#line 482
;
	rc = bi_message_register(env, mp->msglist, msg, MF_MSG_MAILBOX);
		if (!(rc >= 0))
#line 484
		(
#line 484
	env_throw_bi(env, mfe_failure, "message_get_part", _("no more message slots available"))
#line 484
)
#line 486
;
	
#line 487
do {
#line 487
  push(env, (STKVAL)(mft_number)(rc));
#line 487
  goto endlab;
#line 487
} while (0);
}
endlab:
#line 489
        env_function_cleanup_flush(env, NULL);
#line 489
	return;
#line 489
}


/* Reading */

/* string message_rewind(number nmsg) */
void
#line 495
bi_message_rewind(eval_environ_t env)
#line 495

#line 495

#line 495 "msg.bi"
{
#line 495
	
#line 495

#line 495

#line 495
long  nmsg;
#line 495
        
#line 495
get_numeric_arg(env, 0, &nmsg);
#line 495
        
#line 495

#line 495
        adjust_stack(env, 1);
#line 495

#line 495

#line 495
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 495
		prog_trace(env, "message_rewind %lu",nmsg);;
#line 495

{
	
#line 497
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 497
	struct mf_message *mp;
#line 497
			
#line 497
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 497
		(
#line 497
	env_throw_bi(env, mfe_range, "message_rewind", _("invalid message descriptor"))
#line 497
)
#line 497
;
#line 497
	mp = mtab + nmsg;
#line 497
		if (!(mp->msg))
#line 497
		(
#line 497
	env_throw_bi(env, mfe_failure, "message_rewind", _("message not open"))
#line 497
)
#line 497

#line 497
;
	mu_stream_destroy(&mp->mstr);
}

#line 500
        env_function_cleanup_flush(env, NULL);
#line 500
	return;
#line 500
}

/* string message_read_line(number nmsg) */
void
#line 503
bi_message_read_line(eval_environ_t env)
#line 503

#line 503

#line 503 "msg.bi"
{
#line 503
	
#line 503

#line 503

#line 503
long  nmsg;
#line 503
        
#line 503
get_numeric_arg(env, 0, &nmsg);
#line 503
        
#line 503

#line 503
        adjust_stack(env, 1);
#line 503

#line 503

#line 503
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 503
		prog_trace(env, "message_read_line %lu",nmsg);;
#line 503

{
	int rc;
	size_t size;
	
#line 507
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 507
	struct mf_message *mp;
#line 507
			
#line 507
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 507
		(
#line 507
	env_throw_bi(env, mfe_range, "message_read_line", _("invalid message descriptor"))
#line 507
)
#line 507
;
#line 507
	mp = mtab + nmsg;
#line 507
		if (!(mp->msg))
#line 507
		(
#line 507
	env_throw_bi(env, mfe_failure, "message_read_line", _("message not open"))
#line 507
)
#line 507

#line 507
;

	if (!mp->mstr) {
		rc = mu_message_get_streamref(mp->msg, &mp->mstr);
			if (!(rc == 0))
#line 511
		(
#line 511
	env_throw_bi(env, mfe_failure, "message_read_line", "mu_message_get_stream: %s",mu_strerror(rc))
#line 511
)
#line 514
;
	}
	rc = mu_stream_getline(mp->mstr, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 517
		(
#line 517
	env_throw_bi(env, mfe_io, "message_read_line", "mu_stream_getline: %s",mu_strerror(rc))
#line 517
)
#line 520
;
		if (!(size > 0))
#line 521
		(
#line 521
	env_throw_bi(env, mfe_eof, "message_read_line", "mu_stream_getline: %s",_("end of input"))
#line 521
)
#line 524
;
	
#line 525
do {
#line 525
  pushs(env, mp->buf);
#line 525
  goto endlab;
#line 525
} while (0);
}
endlab:
#line 527
        env_function_cleanup_flush(env, NULL);
#line 527
	return;
#line 527
}

/* string message_body_rewind(number nmsg) */
void
#line 530
bi_message_body_rewind(eval_environ_t env)
#line 530

#line 530

#line 530 "msg.bi"
{
#line 530
	
#line 530

#line 530

#line 530
long  nmsg;
#line 530
        
#line 530
get_numeric_arg(env, 0, &nmsg);
#line 530
        
#line 530

#line 530
        adjust_stack(env, 1);
#line 530

#line 530

#line 530
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 530
		prog_trace(env, "message_body_rewind %lu",nmsg);;
#line 530

{
	
#line 532
	
#line 532
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 532
	struct mf_message *mp;
#line 532
			
#line 532
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 532
		(
#line 532
	env_throw_bi(env, mfe_range, "message_body_rewind", _("invalid message descriptor"))
#line 532
)
#line 532
;
#line 532
	mp = mtab + nmsg;
#line 532
		if (!(mp->msg))
#line 532
		(
#line 532
	env_throw_bi(env, mfe_failure, "message_body_rewind", _("message not open"))
#line 532
)
#line 532

#line 532
;
#line 532
	if (!mp->body) {
#line 532
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 532
			if (!(rc == 0))
#line 532
		(
#line 532
	env_throw_bi(env, mfe_failure, "message_body_rewind", "mu_message_get_body: %s",mu_strerror(rc))
#line 532
)
#line 532
;
#line 532
	}	  
#line 532
;
	mu_stream_destroy(&mp->bstr);
}

#line 535
        env_function_cleanup_flush(env, NULL);
#line 535
	return;
#line 535
}

/* string message_read_body_line(number msg)  */
void
#line 538
bi_message_read_body_line(eval_environ_t env)
#line 538

#line 538

#line 538 "msg.bi"
{
#line 538
	
#line 538

#line 538

#line 538
long  nmsg;
#line 538
        
#line 538
get_numeric_arg(env, 0, &nmsg);
#line 538
        
#line 538

#line 538
        adjust_stack(env, 1);
#line 538

#line 538

#line 538
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 538
		prog_trace(env, "message_read_body_line %lu",nmsg);;
#line 538

{
	int rc;
	size_t size;
	
#line 542
	
#line 542
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 542
	struct mf_message *mp;
#line 542
			
#line 542
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 542
		(
#line 542
	env_throw_bi(env, mfe_range, "message_read_body_line", _("invalid message descriptor"))
#line 542
)
#line 542
;
#line 542
	mp = mtab + nmsg;
#line 542
		if (!(mp->msg))
#line 542
		(
#line 542
	env_throw_bi(env, mfe_failure, "message_read_body_line", _("message not open"))
#line 542
)
#line 542

#line 542
;
#line 542
	if (!mp->body) {
#line 542
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 542
			if (!(rc == 0))
#line 542
		(
#line 542
	env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_message_get_body: %s",mu_strerror(rc))
#line 542
)
#line 542
;
#line 542
	}	  
#line 542
;
	
	if (!mp->bstr) {
		rc = mu_body_get_streamref(mp->body, &mp->bstr);
			if (!(rc == 0))
#line 546
		(
#line 546
	env_throw_bi(env, mfe_failure, "message_read_body_line", "mu_body_get_stream: %s",mu_strerror(rc))
#line 546
)
#line 549
;
	}
	rc = mu_stream_getline(mp->bstr, &mp->buf, &mp->bufsize, &size);
		if (!(rc == 0))
#line 552
		(
#line 552
	env_throw_bi(env, mfe_io, "message_read_body_line", "mu_stream_getline: %s",mu_strerror(rc))
#line 552
)
#line 555
;
		if (!(size > 0))
#line 556
		(
#line 556
	env_throw_bi(env, mfe_eof, "message_read_body_line", "mu_stream_getline: %s",_("end of input"))
#line 556
)
#line 559
;
	
#line 560
do {
#line 560
  pushs(env, mp->buf);
#line 560
  goto endlab;
#line 560
} while (0);
}
endlab:
#line 562
        env_function_cleanup_flush(env, NULL);
#line 562
	return;
#line 562
}

/* string message_to_stream(number fd, number msg; string mu_filter_chain) */
void
#line 565
bi_message_to_stream(eval_environ_t env)
#line 565

#line 565

#line 565 "msg.bi"
{
#line 565
	
#line 565

#line 565
long __bi_argcnt;
#line 565
long  fd;
#line 565
        long  nmsg;
#line 565
        char *  fltchain;
#line 565
        
#line 565
get_numeric_arg(env, 1, &fd);
#line 565
        get_numeric_arg(env, 2, &nmsg);
#line 565
        get_string_arg(env, 3, &fltchain);
#line 565
        
#line 565
get_numeric_arg(env, 0, &__bi_argcnt);
#line 565
        adjust_stack(env, __bi_argcnt + 1);
#line 565

#line 565

#line 565
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 565
		prog_trace(env, "message_to_stream %lu %lu %s",fd, nmsg, ((__bi_argcnt > 2) ? fltchain : ""));;

{
	int rc;
	int yes = 1;
	mu_stream_t dst;
	char *flts = ((__bi_argcnt > 2) ? fltchain : 0);
	
	
#line 573
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 573
	struct mf_message *mp;
#line 573
			
#line 573
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 573
		(
#line 573
	env_throw_bi(env, mfe_range, "message_to_stream", _("invalid message descriptor"))
#line 573
)
#line 573
;
#line 573
	mp = mtab + nmsg;
#line 573
		if (!(mp->msg))
#line 573
		(
#line 573
	env_throw_bi(env, mfe_failure, "message_to_stream", _("message not open"))
#line 573
)
#line 573

#line 573
;
	
	rc = mu_fd_stream_create(&dst, NULL, _bi_io_fd(env, fd, 1),
				 MU_STREAM_WRITE);
		if (!(rc == 0))
#line 577
		(
#line 577
	env_throw_bi(env, mfe_failure, "message_to_stream", "mu_fd_stream_create: %s",mu_strerror(rc))
#line 577
)
#line 580
;
	mu_stream_ioctl(dst, MU_IOCTL_FD, MU_IOCTL_FD_SET_BORROW, &yes);
	if (flts) {
		struct mu_wordsplit ws;
		mu_stream_t flt;
		
		rc = mu_wordsplit(flts, &ws, MU_WRDSF_DEFFLAGS);
			if (!(rc == 0))
#line 587
		(
#line 587
	env_throw_bi(env, mfe_failure, "message_to_stream", "mu_wordsplit: %s",mu_wordsplit_strerror(&ws))
#line 587
)
#line 590
;
		rc = mu_filter_chain_create(&flt, dst, MU_FILTER_ENCODE,
					    MU_STREAM_WRITE,
					    ws.ws_wordc, ws.ws_wordv);
		mu_wordsplit_free(&ws);
			if (!(rc == 0))
#line 595
		(
#line 595
	env_throw_bi(env, mfe_failure, "message_to_stream", "mu_filter_chain_create(\"%s\"): %s",flts,mu_strerror(rc))
#line 595
)
#line 599
;
		mu_stream_unref(dst);
		dst = flt;
	}

	if (!mp->mstr) {
		rc = mu_message_get_streamref(mp->msg, &mp->mstr);
			if (!(rc == 0))
#line 606
		(
#line 606
	env_throw_bi(env, mfe_failure, "message_to_stream", "mu_message_get_stream: %s",mu_strerror(rc))
#line 606
)
#line 609
;
	}
	rc = mu_stream_copy(dst, mp->mstr, 0, NULL);
		if (!(rc == 0))
#line 612
		(
#line 612
	env_throw_bi(env, mfe_failure, "message_to_stream", "mu_stream_copy: %s",mu_strerror(rc))
#line 612
)
#line 615
;
	mu_stream_close(dst);
	mu_stream_unref(dst);
}

#line 619
        env_function_cleanup_flush(env, NULL);
#line 619
	return;
#line 619
}

/* number message_from_stream(number fd; string mu_filter_chain) */
void
#line 622
bi_message_from_stream(eval_environ_t env)
#line 622

#line 622

#line 622 "msg.bi"
{
#line 622
	
#line 622

#line 622
long __bi_argcnt;
#line 622
long  fd;
#line 622
        char *  fltchain;
#line 622
        
#line 622
get_numeric_arg(env, 1, &fd);
#line 622
        get_string_arg(env, 2, &fltchain);
#line 622
        
#line 622
get_numeric_arg(env, 0, &__bi_argcnt);
#line 622
        adjust_stack(env, __bi_argcnt + 1);
#line 622

#line 622

#line 622
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 622
		prog_trace(env, "message_from_stream %lu %s",fd, ((__bi_argcnt > 1) ? fltchain : ""));;

{
	int rc;
	int yes = 1;
	mu_stream_t src;
	char *flts = ((__bi_argcnt > 1) ? fltchain : 0);
	mu_message_t msg;
	
	rc = mu_fd_stream_create(&src, NULL, _bi_io_fd(env, fd, 0),
				 MU_STREAM_READ|MU_STREAM_SEEK);
				    
		if (!(rc == 0))
#line 634
		(
#line 634
	env_throw_bi(env, mfe_failure, "message_from_stream", "mu_fd_stream_create: %s",mu_strerror(rc))
#line 634
)
#line 637
;
	mu_stream_ioctl(src, MU_IOCTL_FD, MU_IOCTL_FD_SET_BORROW, &yes);
	if (flts) {
		struct mu_wordsplit ws;
		mu_stream_t flt;
		
		rc = mu_wordsplit(flts, &ws, MU_WRDSF_DEFFLAGS);
			if (!(rc == 0))
#line 644
		(
#line 644
	env_throw_bi(env, mfe_failure, "message_from_stream", "mu_wordsplit: %s",mu_wordsplit_strerror(&ws))
#line 644
)
#line 647
;
		rc = mu_filter_chain_create(&flt, src, MU_FILTER_ENCODE,
					    MU_STREAM_READ,
					    ws.ws_wordc, ws.ws_wordv);
		mu_wordsplit_free(&ws);
			if (!(rc == 0))
#line 652
		(
#line 652
	env_throw_bi(env, mfe_failure, "message_from_stream", "mu_filter_chain_create(\"%s\"): %s",flts,mu_strerror(rc))
#line 652
)
#line 656
;
		mu_stream_unref(src);
		src = flt;
	}

	msg = _builtin_mu_stream_to_message(src, env, "message_from_stream");

	rc = bi_message_register(env, NULL, msg, MF_MSG_STANDALONE);
	if (rc < 0) {
		mu_message_destroy(&msg, mu_message_get_owner(msg));
		(
#line 666
	env_throw_bi(env, mfe_failure, "message_from_stream", _("no more message slots available"))
#line 666
);
#line 668
	}
	
#line 669
do {
#line 669
  push(env, (STKVAL)(mft_number)(rc));
#line 669
  goto endlab;
#line 669
} while (0);
}
endlab:
#line 671
        env_function_cleanup_flush(env, NULL);
#line 671
	return;
#line 671
}

/* string message_body_to_stream(number fd, number msg; string mu_filter_chain) */
void
#line 674
bi_message_body_to_stream(eval_environ_t env)
#line 674

#line 674

#line 674 "msg.bi"
{
#line 674
	
#line 674

#line 674
long __bi_argcnt;
#line 674
long  fd;
#line 674
        long  nmsg;
#line 674
        char *  fltchain;
#line 674
        
#line 674
get_numeric_arg(env, 1, &fd);
#line 674
        get_numeric_arg(env, 2, &nmsg);
#line 674
        get_string_arg(env, 3, &fltchain);
#line 674
        
#line 674
get_numeric_arg(env, 0, &__bi_argcnt);
#line 674
        adjust_stack(env, __bi_argcnt + 1);
#line 674

#line 674

#line 674
	if (builtin_module_trace(BUILTIN_IDX_msg))
#line 674
		prog_trace(env, "message_body_to_stream %lu %lu %s",fd, nmsg, ((__bi_argcnt > 2) ? fltchain : ""));;

{
	int rc;
	int yes = 1;
	mu_stream_t dst;
	char *flts = ((__bi_argcnt > 2) ? fltchain : 0);
	
	
#line 682
	
#line 682
	struct mf_message *mtab = env_get_builtin_priv(env,MSGTAB_id);
#line 682
	struct mf_message *mp;
#line 682
			
#line 682
		if (!(nmsg >= 0 && nmsg < nmsgs))
#line 682
		(
#line 682
	env_throw_bi(env, mfe_range, "message_body_to_stream", _("invalid message descriptor"))
#line 682
)
#line 682
;
#line 682
	mp = mtab + nmsg;
#line 682
		if (!(mp->msg))
#line 682
		(
#line 682
	env_throw_bi(env, mfe_failure, "message_body_to_stream", _("message not open"))
#line 682
)
#line 682

#line 682
;
#line 682
	if (!mp->body) {
#line 682
		int rc = mu_message_get_body(mp->msg, &mp->body);
#line 682
			if (!(rc == 0))
#line 682
		(
#line 682
	env_throw_bi(env, mfe_failure, "message_body_to_stream", "mu_message_get_body: %s",mu_strerror(rc))
#line 682
)
#line 682
;
#line 682
	}	  
#line 682
;
	
	rc = mu_fd_stream_create(&dst, NULL, _bi_io_fd(env, fd, 1),
				 MU_STREAM_WRITE);
		if (!(rc == 0))
#line 686
		(
#line 686
	env_throw_bi(env, mfe_failure, "message_body_to_stream", "mu_fd_stream_create: %s",mu_strerror(rc))
#line 686
)
#line 689
;
	mu_stream_ioctl(dst, MU_IOCTL_FD, MU_IOCTL_FD_SET_BORROW, &yes);
	if (flts) {
		struct mu_wordsplit ws;
		mu_stream_t flt;
		
		rc = mu_wordsplit(flts, &ws, MU_WRDSF_DEFFLAGS);
			if (!(rc == 0))
#line 696
		(
#line 696
	env_throw_bi(env, mfe_failure, "message_body_to_stream", "mu_wordsplit: %s",mu_wordsplit_strerror(&ws))
#line 696
)
#line 699
;
		rc = mu_filter_chain_create(&flt, dst, MU_FILTER_ENCODE,
					    MU_STREAM_WRITE,
					    ws.ws_wordc, ws.ws_wordv);
		mu_wordsplit_free(&ws);
			if (!(rc == 0))
#line 704
		(
#line 704
	env_throw_bi(env, mfe_failure, "message_body_to_stream", "mu_filter_chain_create(\"%s\"): %s",flts,mu_strerror(rc))
#line 704
)
#line 708
;
		mu_stream_unref(dst);
		dst = flt;
	}

	if (!mp->bstr) {
		rc = mu_body_get_streamref(mp->body, &mp->bstr);
			if (!(rc == 0))
#line 715
		(
#line 715
	env_throw_bi(env, mfe_failure, "message_body_to_stream", "mu_body_get_stream: %s",mu_strerror(rc))
#line 715
)
#line 718
;
	}
	rc = mu_stream_copy(dst, mp->bstr, 0, NULL);
		if (!(rc == 0))
#line 721
		(
#line 721
	env_throw_bi(env, mfe_failure, "message_body_to_stream", "mu_stream_copy: %s",mu_strerror(rc))
#line 721
)
#line 724
;
	mu_stream_close(dst);
	mu_stream_unref(dst);
}

#line 728
        env_function_cleanup_flush(env, NULL);
#line 728
	return;
#line 728
}


#line 730
void
#line 730
msg_init_builtin()
#line 730
{
#line 730
	
#line 730
	#line 57 "msg.bi"
MSGTAB_id = builtin_priv_register(alloc_msgs, destroy_msgs,
#line 57
drop_current_message);
#line 182 "msg.bi"
va_builtin_install_ex("message_close", bi_message_close, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 190 "msg.bi"
va_builtin_install_ex("message_size", bi_message_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 208 "msg.bi"
va_builtin_install_ex("message_lines", bi_message_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 224 "msg.bi"
va_builtin_install_ex("message_body_size", bi_message_body_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 242 "msg.bi"
va_builtin_install_ex("message_body_is_empty", bi_message_body_is_empty, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 293 "msg.bi"
va_builtin_install_ex("message_body_lines", bi_message_body_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 312 "msg.bi"
va_builtin_install_ex("message_header_size", bi_message_header_size, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 330 "msg.bi"
va_builtin_install_ex("message_header_lines", bi_message_header_lines, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 346 "msg.bi"
va_builtin_install_ex("message_header_count", bi_message_header_count, 0, dtype_number, 2, 1, 0|0, dtype_number, dtype_string);
#line 377 "msg.bi"
va_builtin_install_ex("message_has_header", bi_message_has_header, 0, dtype_number, 3, 1, 0|0, dtype_number, dtype_string, dtype_number);
#line 390 "msg.bi"
va_builtin_install_ex("message_find_header", bi_message_find_header, 0, dtype_string, 3, 1, 0|0, dtype_number, dtype_string, dtype_number);
#line 407 "msg.bi"
va_builtin_install_ex("message_nth_header_name", bi_message_nth_header_name, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_number);
#line 423 "msg.bi"
va_builtin_install_ex("message_nth_header_value", bi_message_nth_header_value, 0, dtype_string, 2, 0, 0|0, dtype_number, dtype_number);
#line 442 "msg.bi"
va_builtin_install_ex("message_is_multipart", bi_message_is_multipart, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 457 "msg.bi"
va_builtin_install_ex("message_count_parts", bi_message_count_parts, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 472 "msg.bi"
va_builtin_install_ex("message_get_part", bi_message_get_part, 0, dtype_number, 2, 0, 0|0, dtype_number, dtype_number);
#line 495 "msg.bi"
va_builtin_install_ex("message_rewind", bi_message_rewind, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 503 "msg.bi"
va_builtin_install_ex("message_read_line", bi_message_read_line, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 530 "msg.bi"
va_builtin_install_ex("message_body_rewind", bi_message_body_rewind, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 538 "msg.bi"
va_builtin_install_ex("message_read_body_line", bi_message_read_body_line, 0, dtype_string, 1, 0, 0|0, dtype_number);
#line 565 "msg.bi"
va_builtin_install_ex("message_to_stream", bi_message_to_stream, 0, dtype_unspecified, 3, 1, 0|0, dtype_number, dtype_number, dtype_string);
#line 622 "msg.bi"
va_builtin_install_ex("message_from_stream", bi_message_from_stream, 0, dtype_number, 2, 1, 0|0, dtype_number, dtype_string);
#line 674 "msg.bi"
va_builtin_install_ex("message_body_to_stream", bi_message_body_to_stream, 0, dtype_unspecified, 3, 1, 0|0, dtype_number, dtype_number, dtype_string);

#line 730 "msg.bi"
	
#line 730
	 mf_add_runtime_params(msg_cfg_param);
#line 730
	 
#line 730
}
#line 730 "msg.bi"

#line 732

#line 761 "../../src/builtin/snarf.m4"

#line 761

